signature DeflateBits =
sig

	(*
	 convert boolean to integer or character
	*)
	
	val bit_to_int : bool -> int
	
	val bit_to_char : bool -> char
	
	(*
	 convert integer into list of boolean, lsb or msb first
	 int : number of bits in result
	 int : integer to convert
	 bool list : result
	*)
	
	val explode_fixed_lsb_first : int -> int -> bool list
	
	val explode_fixed_msb_first : int -> int -> bool list

	(*
	 convert list of boolean to integer, lsb or msb first
	*)
	
	val to_int_lsb_first : bool list -> int
	
	val to_int_msb_first : bool list -> int
	
	val to_string : bool list -> string
	
	(*
	 misc
	*)
	
	val pow2 : int -> int
		
	(* self test *)
	val tests: bool list  
	 
end
