signature DeflateIO =
sig

	(*
	 bit/byteIO stream
	*)
	
	type byteio
	
	(* constructor *)
	
	val from_input : int list -> byteio
	
	(* debug *)
	
	val io_to_string : byteio -> string
	
	(* make one more byte into bits *)
	 
	val forth : byteio -> byteio
	
	(* output *)
	
	val output : byteio -> int list
	
	val append_from_output : byteio -> int -> int -> byteio
	
	val append_byte : byteio -> int -> byteio
	
	val append_bytes : byteio -> int list -> byteio
	
	(* take and drop bits from input *)
	
	val take_bytes : byteio -> int -> int list
	
	val drop_bytes : byteio -> int -> byteio
	
	val take_zero_string : byteio -> string
	
	val drop_zero_string : byteio -> byteio
	
	val take_bits : byteio -> int -> bool list
	
	val drop_bits : byteio -> int -> byteio
	
	val drop_to_byte : byteio -> byteio
	
	val get_fixed : int -> byteio -> int * byteio
		
	(* self test *)
	val tests: bool list  
	 
end
